#! /bin/sh

########################################################################
# script de chargement du validateur de format
# auteur prat@cines.fr
# last maj : 2010/08/02
# ce script est à charger dans l'environnement du code utilisant le validateur
########################################################################

cd `dirname $0`
export LANG=fr_FR.UTF-8

# utile pour le bon fonctionnement de mplayer via cron
export TERM=xterm

# home directory of validator application
export FV_HOME=/opt/formatValidator2

#  Java Native Interface
#  La variable système java.library.path comporte une liste de répertoire qui seront utilisés par la machine virtuelle 
#  pour rechercher les librairies natives via la méthode System.loadLibrary()
#  La valeur par défaut du java.library.path dépend de variable d'environnement système et utilise son séparateur de chemin 
#  ( ';' sous Windows et ':' pour les autres systèmes - on peut utiliser la valeur de File.pathSeparatorChar pour obtenir cette information dynamiquement) :
#  Sous Windows, cela correspond à la variable d'environnement PATH (également utilisé pour rechercher les applications).
#  Sous Unix/Linux, cela correspond à la variable d'environnement LD_LIBRARY_PATH.
#  En Java on peut utiliser la méthode System.getProperty() pour vérifier sa valeur : 
#  String javaLibraryPath = System.getProperty("java.library.path");
#  Il est possible de modifier la valeur du java.library.path en redéfinissant la valeur de la propriété lors du lancement de l'application, 
#  en rajoutant le paramètre -Djava.library.path=la_nouvelle_valeur lors de l'appel de la JVM.

export LIB_JNI_OPTION='-Djava.library.path=/usr/local/lib64:/usr/lib64:/lib64'

export LD_LIBRARY_PATH=$FV_HOME/libext:$FV_HOME/tools/libtheora-1.1.1/lib:$FV_HOME/tools/libogg-1.1.4/lib/:$FV_HOME/libvorbis-1.2.3/lib/:$LD_LIBRARY_PATH
export MAGICK_TMPDIR=$FV_HOME/tmp/
export VALIDATOR_JARS=$FV_HOME/formatValidator.jar:$FV_HOME/libext/*
