/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.format;

import java.io.File;

import fr.cines.pac.formatValidator.Validator;
import fr.cines.pac.formatValidator.exception.FormatValidatorException;
import fr.cines.pac.formatValidator.util.*;

public class CmdMgr {

	/**
	 * Gestion des interactions en ligne de commande POSIX
	 */
	
	/** identifiant du parametre chemin à analyser */
	final static String PATH_PARAM				="-path";
	
	/** identifiant parametre permettant de focer un validateur spécifique */
	final static String FORCE_VALIDATOR_PARAM	="-force";

	/** valeur de l'index du parametre PATH_PARAM */
	private static int pathIndexValue;
	
	/** valeur de l'index du parametre FORCE_VALIDATOR_PARAM */
	private static int forceValidatorIndexValue;

	/** valeur du parametre PATH_PARAM */
	private static String pathValue;
	
	/** valeur du parametre FORCE_VALIDATOR_PARAM */
	private static String forceValidatorValue;

	public static void main(String[] args) throws FormatValidatorException{
		System.out.println("parametre d'entrees : "+getString(args));

		int i=0;
		for(String s : args){
			if(s.equalsIgnoreCase(PATH_PARAM))						pathIndexValue			=i+1;
			if(s.equalsIgnoreCase(FORCE_VALIDATOR_PARAM))   		forceValidatorIndexValue=i+1;
			i++;
		}

		if(pathIndexValue>0)
			pathValue = args[pathIndexValue];
		else{
			showHelp();
			return;
		}
		if(forceValidatorIndexValue>0)
			forceValidatorValue = args[forceValidatorIndexValue];

		if(forceValidatorValue!=null){
			Validator validator = Validator.getFromClassName(forceValidatorValue);
			validator.init(new File(pathValue));
			System.out.println(validator.getMessage());
			return;
		}

		if(pathValue==null){
			showHelp();
			return;
		}
		File file = new File(pathValue);
		if(!file.canRead()){
			System.out.println("file or directory is not readable : "+pathValue);
			return;
		}
		Config.getInstance();

		FSValidatorHandler dFVH = new FSValidatorHandler();
		FSWalker directoryReader = new FSWalker(file,dFVH);
		
		directoryReader.start();
	}

	private static String getString(String[] array){
		if(array==null) return "";
		StringBuffer sb = new StringBuffer();
		int i=0;
		for(String s : array){
			sb.append("["+i+"="+s+"]");
			i++;
		}
		return sb.toString();
	}
	static void showHelp(){
		System.out.println("les options suivantes sont obligatoires : ");
		System.out.println(PATH_PARAM+" "+"emplacement du système de fichier à analyser");
	}
}