/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.*;
import edu.harvard.hul.ois.jhove.module.AiffModule;

/**
 * Classe de validation des fichiers au format AIFF
 */
public class AiffValidator extends AudioValidator {

	static String ALLOW_PROFIL = "AIFF";
	
	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new AiffModule());	
	}
	
	@Override
	void checkIsValid() throws NotValidException {
		this.getToolsMgr().getJhoveTool().checkIsValid();
	}

	@Override
	void checkIsWellFormed() throws NotWellFormedException{
		this.getToolsMgr().getJhoveTool().checkIsWellFormed();
		this.getToolsMgr().getJhoveTool().checkProfil(ALLOW_PROFIL);
	}
	
}