/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.*;


import edu.harvard.hul.ois.jhove.module.AsciiModule;

/**
 * Classe permettant la validation des fichiers au format ASCII
 */
public class AsciiValidator extends Validator {

	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new AsciiModule());	
	}
	
	@Override
	void checkIsValid() throws NotValidException {
		this.getToolsMgr().getJhoveTool().checkIsValid();
	}
	

	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		this.getToolsMgr().getJhoveTool().checkIsWellFormed();
		this.checkAllowFormat();
		this.checkAllowVersion();
	}

	@Override
	void setFormatToolsInfo() {
		this.getFormatToolsInfo().setShortName(super.getToolsMgr().getJhoveTool().getFileFormat());
		this.getFormatToolsInfo().setVersion(super.getToolsMgr().getJhoveTool().getVersionFormat());
	}
}