/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.*;
/**
 * Interface devant etre implémentée par toutes les classes de validateur
 * La méthode d'initialisation devant impérativement être appelée pour pouvoir utiliser
 * la classe.
 */
public interface FileFormatValidator{
    /**
     * Méthode d'initialisation devant impérativement être appelée pour pouvoir utiliser
     * la classe.
     * @param file Fichier
     * @throws ArcsysCinesException
     */
	
    @Deprecated
    public void initFile(File file, String donothing) throws FormatValidatorException;

    /**
     * Indique si le fichier est valide
     */
    public boolean isValid();

    /**
     * Indique si le fichier est bien formé
     */
    public boolean isWellFormed();
    
    /**
     * Indique si le fichier est bien formé
     */
    public boolean isArchivable();
    
    /**
     * Indique les messages d'erreur
     */
    public String getMessage() throws FormatValidatorException;
    
    public String getVersionFormat();
    
}
