/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.*;
import edu.harvard.hul.ois.jhove.module.GifModule;

/**
 * Classe permettant la validation des fichiers au format GIF
 */
public class GifValidator extends Validator {
	
	static String I_MAGICK_FORMAT ="GIF";
	
	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new GifModule());	
	}
		
	@Override
	void checkIsValid() throws NotValidException {
		this.getToolsMgr().getJhoveTool().checkIsValid();
		this.getToolsMgr().getIMagickTool().checkIsValid();
	}

	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		this.checkAllowFormat();
		this.getToolsMgr().getJhoveTool().checkIsWellFormed();
		this.getToolsMgr().getIMagickTool().checkIsWellFormed(I_MAGICK_FORMAT);
		this.checkAllowVersion();
	}

	@Override
	void setFormatToolsInfo() {
		this.getFormatToolsInfo().setShortName(this.getToolsMgr().getJhoveTool().getFileFormat());
		this.getFormatToolsInfo().setVersion(this.getToolsMgr().getJhoveTool().getVersionFormat());
	}
}
