/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.FormatValidatorException;
import fr.cines.pac.formatValidator.exception.NotValidException;
import fr.cines.pac.formatValidator.exception.NotWellFormedException;


import edu.harvard.hul.ois.jhove.module.HtmlModule;

/**
 * Classe permettant la validation des fichiers HTML
 */
public class HtmlValidator extends Validator {
	
	
	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new HtmlModule());	
	}
	
	@Override
	void checkIsValid() throws NotValidException {
		this.getToolsMgr().getJhoveTool().checkIsValid();
	}

	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		this.checkAllowFormat();
	// pprat do not check for moment 	this.checkAllowVersion();
		this.getToolsMgr().getJhoveTool().checkIsWellFormed();
	}

	@Override
	void setFormatToolsInfo() {
		this.getFormatToolsInfo().setShortName(this.getToolsMgr().getJhoveTool().getFileFormat());
		this.getFormatToolsInfo().setVersion(this.getToolsMgr().getJhoveTool().getVersionFormat().replace("HTML", "").trim());
		
	}
}