/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.*;
import edu.harvard.hul.ois.jhove.module.JpegModule;

/**
 * Classe permettant la validation des fichiers au format JPEG
 */
public class JpegValidator extends Validator {

	static String I_MAGICK_FORMAT ="JPEG";

	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new JpegModule());	
	}
	
	@Override
	void checkIsValid() throws NotValidException {
		// TODO Auto-generated method stub
		this.getToolsMgr().getJhoveTool().checkIsValid();
		this.getToolsMgr().getIMagickTool().checkIsValid();
	}

	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		// TODO Auto-generated method stub
		this.checkAllowFormat();
		this.checkAllowVersion();
		this.getToolsMgr().getJhoveTool().checkIsWellFormed();
		this.getToolsMgr().getIMagickTool().checkIsWellFormed(I_MAGICK_FORMAT);
	}

	@Override
	void setFormatToolsInfo() {
		this.getFormatToolsInfo().setShortName(this.getToolsMgr().getJhoveTool().getFileFormat());
		this.getFormatToolsInfo().setVersion(this.getToolsMgr().getJhoveTool().getVersionFormat());
	}
}
