/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import fr.cines.pac.formatValidator.exception.NotValidException;
import fr.cines.pac.formatValidator.exception.NotWellFormedException;

/**
 * Classe de substitution si aucun validateur n'est trouvé pour le format designé
 */

public class NaValidator extends Validator {

 @Override
 void checkIsValid() throws NotValidException {
	throw new NotValidException(this.getClass(),"format NA (Non Applicable) pour le controle de validité");
 }

 @Override
 void checkIsWellFormed() throws NotWellFormedException {
	throw new NotWellFormedException(this.getClass(),"format NA (Non Applicable) pour le controle de forme");	
 }

 @Override
 void setFormatToolsInfo() {
 }

}