/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import fr.cines.pac.formatValidator.exception.*;

/**
 * Classe permettant la validation des fichiers au format open document ODT
 */
public class ODTValidator extends Validator {
	
    public static final String MEDIA_TYPE = "application/vnd.oasis.opendocument.text";
	public static final String FORMAT_ID_TYPE = "odt";

	@Override
	void checkIsValid() throws NotValidException {
		this.getToolsMgr().getOdfTool().checkIsValid();
	}

	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		this.checkAllowFormat();
		this.checkAllowVersion();
	}

	@Override
	void setFormatToolsInfo() {
		String mediaType = this.getToolsMgr().getOdfTool().getMediaType();
		if(mediaType.equalsIgnoreCase(MEDIA_TYPE))
			this.getFormatToolsInfo().setShortName(FORMAT_ID_TYPE);
		this.getFormatToolsInfo().setVersion(this.getToolsMgr().getOdfTool().getVersion());
	}
}