/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.*;

import edu.harvard.hul.ois.jhove.module.*;

/**
 * Classe permettant la validation des fichiers au format PDF
 */
public class PdfValidator extends Validator {
	
	public final static String ERROR_1 = "Improperly formed date";
	
	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new PdfModule());	
	}

	@Override
	void checkIsValid() throws NotValidException {
		// TODO Auto-generated method stub
		this.getToolsMgr().getJhoveTool().checkIsValid();
	}

	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		this.checkAllowFormat();
		this.checkAllowVersion();
		this.getToolsMgr().getJhoveTool().checkIsWellFormed();
	}

	@Override
	void setFormatToolsInfo() {
		this.getFormatToolsInfo().setShortName(this.getToolsMgr().getJhoveTool().getFileFormat());
		this.getFormatToolsInfo().setVersion(this.getToolsMgr().getJhoveTool().getVersionFormat());
	}
}