/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.*;

/**
 * Classe permettant la validation des fichiers au format PNG
 */
public class PngValidator extends Validator{

	final static int[] validDroidIds = {664,665,666};  

	static String I_MAGICK_FORMAT ="PNG";
	
	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setDroidTool(validDroidIds);
	}

	@Override
	void checkIsValid() throws NotValidException {
		this.getToolsMgr().getIMagickTool().checkIsValid();
	}

	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		this.checkAllowFormat();
		this.getToolsMgr().getIMagickTool().checkIsWellFormed(I_MAGICK_FORMAT);
		this.checkAllowVersion();
	}

	@Override
	void setFormatToolsInfo() {
		this.getFormatToolsInfo().setShortName(this.getToolsMgr().getDroidTool().getFormatPacId());
		this.getFormatToolsInfo().setVersion(this.getToolsMgr().getDroidTool().getVersionFormat());	
	}
}