/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.*;
import edu.harvard.hul.ois.jhove.module.TiffModule;

/**
 * Classe permettant la validation des fichiers au format TIFF
 */
public class TiffValidator extends Validator {

	static String I_MAGICK_FORMAT ="TIFF";
	
	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new TiffModule());
	}
	
	@Override
	void checkIsValid() throws NotValidException {
		this.getToolsMgr().getJhoveTool().checkIsValid();
		this.getToolsMgr().getIMagickTool().checkIsValid();
		
	}
	
	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		this.checkAllowFormat();
		this.checkAllowVersion();
		this.getToolsMgr().getJhoveTool().checkIsWellFormed();
		this.getToolsMgr().getIMagickTool().checkIsWellFormed(I_MAGICK_FORMAT);
		
	}
	
	@Override
	void setFormatToolsInfo() {
		if(this.getToolsMgr().getJhoveTool()==null) System.out.println("nullll");
		this.getFormatToolsInfo().setShortName(this.getToolsMgr().getJhoveTool().getFileFormat());
		this.getFormatToolsInfo().setVersion(this.getToolsMgr().getJhoveTool().getVersionFormat());
	}
}