/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import fr.cines.pac.formatValidator.exception.*;
import edu.harvard.hul.ois.jhove.module.Utf8Module;

/**
 * Classe permettant la validation des fichiers au format UTF8
 */
public class Utf8Validator extends Validator {

	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new Utf8Module());	
	}
	@Override
	void checkIsValid() throws NotValidException {
		// TODO Auto-generated method stub
		this.getToolsMgr().getJhoveTool().checkIsValid();
	}

	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		this.checkAllowFormat();
		this.checkAllowVersion();
		this.getToolsMgr().getJhoveTool().checkIsWellFormed();
	}

	@Override
	void setFormatToolsInfo() {
		this.getFormatToolsInfo().setShortName(this.getToolsMgr().getJhoveTool().getFileFormat());
		this.getFormatToolsInfo().setVersion(this.getToolsMgr().getJhoveTool().getVersionFormat());
	}
}