/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;


import java.io.File;

import fr.cines.pac.formatValidator.exception.*;
import edu.harvard.hul.ois.jhove.module.WaveModule;

/**
 * Classe permettant la validation des fichiers au format WAVE
 */
public class WavValidator extends AudioValidator {

	/**profil de l'outil jhove pour le format WAVE avec encodage PCM*/
	static String JHOVE_PROFIL = "PCMWAVEFORMAT";
		
	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new WaveModule());	
	}
	
	void checkIsWellFormed() throws NotWellFormedException {
		super.checkIsWellFormed();
		this.getToolsMgr().getJhoveTool().checkIsWellFormed();
		this.getToolsMgr().getJhoveTool().checkProfil(JHOVE_PROFIL);
	}
	
	void checkIsValid() throws NotValidException {
		super.checkIsValid();
		this.getToolsMgr().getJhoveTool().checkIsValid();
	}	
}