/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator;

import java.io.File;

import edu.harvard.hul.ois.jhove.module.XmlModule;
import fr.cines.pac.formatValidator.exception.*;

/**
 * Classe permettant la validation des fichiers XML
 */
public class XmlValidator extends Validator {

	public void init(File file) throws FormatValidatorException{
		super.init(file);
		this.getToolsMgr().setJhoveTool(new XmlModule());	
	}
	
	@Override
	void checkIsValid() throws NotValidException {
		//this.getToolsMgr().getJhoveTool().checkIsValid();
		// TODO Auto-generated method stub
		this.getToolsMgr().getCinesXmlTool().checkIsValid();
	}
	
	@Override
	void checkIsWellFormed() throws NotWellFormedException {
		this.checkAllowFormat();
		this.checkAllowVersion();
		this.getToolsMgr().getCinesXmlTool().checkIsWellFormed();
	}
	
	@Override
	void setFormatToolsInfo() {
		this.getFormatToolsInfo().setShortName(this.getToolsMgr().getJhoveTool().getFileFormat());
		this.getFormatToolsInfo().setVersion(this.getToolsMgr().getCinesXmlTool().getXMLVersion());
	}
}
