/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */
package fr.cines.pac.formatValidator.tools;

import org.apache.log4j.Logger;

import uk.gov.nationalarchives.droid.Droid;
import uk.gov.nationalarchives.droid.IdentificationFile;
import fr.cines.pac.format.Config;
import fr.cines.pac.formatValidator.exception.FormatValidatorException;


/**
 * Classe permettant d'utiliser l'outil de validation DROID
 */
public class DroidToolSingleton {
	
	private static Logger logger = Logger.getLogger(DroidToolSingleton.class);
	
	private static DroidToolSingleton instance = null;
	private Droid droid;
	
	private DroidToolSingleton() throws Exception{
			droid = new Droid();
			//String droidconf = ;
			droid.readSignatureFile(Config.getInstance().getDroidConf().getAbsolutePath());
			logger.debug("create DroidSingleton");
	}
	
	public IdentificationFile getIdentification(String file) {
		return droid.identify(file);
	}
	
	public static void initDroidSingleton() throws FormatValidatorException{
		if (instance == null) {
			try {
				instance = new DroidToolSingleton();
			} catch (Exception e) {
				throw new FormatValidatorException("DROIDSingleton.getInstance",e);
				//logger.error("DROIDSingleton.getInstance", e);
			}
		}
	}
	
	public static DroidToolSingleton getInstance() {
		return instance;
	}
}
