/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator.tools;

import java.io.File;

import fr.cines.pac.format.Config;
import fr.cines.pac.format.Format;
import fr.cines.pac.formatValidator.exception.*;

/**
* implémentation de l'outil de validation image Magick
*/

public class IMagickTool extends Tool{
	
	ProcessHandler processTool;
	private String shortName ="";
	
	protected boolean  alreadyRun=false;

	public IMagickTool(File file){
		this.setFile(file);
		String identifyCmd[] = new String[2];
		identifyCmd[0]= Config.getInstance().getIMagickIdentifyPath().getAbsolutePath();
		identifyCmd[1]=this.getFile().getAbsolutePath();
		processTool = new ProcessHandler(identifyCmd);
		processTool.run();

		//	this.SetXmlResponse(processTool.getStandardInput());
		//this.setReader(processTool.getStandardInput());
		//String re = processTool.getInput();
		try{
			String response = processTool.getInput();
			if(response.startsWith("identify:")){
				this.shortName = Format.NON_APPLICABLE;
				return;
			}
			response = response.substring(file.getAbsolutePath().length());
			String[] spli = response.split(" ");
		 this.shortName = spli[1];
		}catch(Exception e){
			shortName = Format.NON_APPLICABLE;
		}
	}

	public String getShortName(){
		return this.shortName;
	}
	
	public void checkIsWellFormed(String  checkedFormat) throws NotWellFormedException {
			if(!checkedFormat.equalsIgnoreCase(this.getShortName()))
				 throw new NotWellFormedException(this.getClass(), "le format trouvé est "+this.getShortName());
	}
	
	public void checkIsValid() throws NotValidException {
		String convertCmd[] = new String[3];
		convertCmd[0]= Config.getInstance().getIMagickConvertPath().getAbsolutePath();
		convertCmd[1]=this.getFile().getAbsolutePath();
		convertCmd[2]="BMP:/dev/null";
		
		processTool = new ProcessHandler(convertCmd);
		processTool.getProcessBuilder().directory(this.getFile().getParentFile());
		processTool.run();
		
		if(!processTool.getInput().isEmpty())
			 throw new NotValidException(this.getClass(), "impossible de décoder le fichier : cause : "+processTool.getInput());
	}
	

}
