package fr.cines.pac.formatValidator.tools;

import java.io.File;
import java.util.Vector;

import org.apache.log4j.Logger;

import fr.cines.pac.format.Config;
import fr.cines.pac.formatValidator.exception.*;

//import edu.harvard.hul.ois.jhove.App;
import edu.harvard.hul.ois.jhove.App;
import edu.harvard.hul.ois.jhove.JhoveBase;
import edu.harvard.hul.ois.jhove.JhoveException;
import edu.harvard.hul.ois.jhove.ModuleBase;
import edu.harvard.hul.ois.jhove.RepInfo;

/**
 * Classe permettant d'utiliser l'outil de validation Jhove
 *
 */
public class JhoveToolSingleton {
	
	private static JhoveToolSingleton instance;
	private JhoveBase jb;
	private static Logger logger = Logger.getLogger(JhoveToolSingleton.class);
	private int[] DATE = { 2005, 5, 26 };
   private App app;
	
	public JhoveToolSingleton() throws FormatValidatorException {
		try {
			jb = new JhoveBase();
		//	String jhoveconf = "null";
			String jhoveconf = Config.getInstance().getJhoveConf().getAbsolutePath();
			
			jb.init(jhoveconf, JhoveBase.getSaxClassFromProperties());
		} catch (JhoveException e) {
			throw new FormatValidatorException("JhoveSingleton",e);
		}

        app = new App("JHOVE", "TEST", DATE, "USAGE", "RIGHTS");
	}
	
	private void initModule(ModuleBase module) throws FormatValidatorException {
        module.setDefaultParams(new Vector<Object>());
        try {
			module.applyDefaultParams();
		} catch (Exception e) {
			throw new FormatValidatorException("JHOVESingleton.initModule",e);
		}
        module.setApp(app);
        module.setBase(jb);
	}
	/*
	private boolean process(ModuleBase module, boolean bool, File file, RepInfo info) throws Exception {
				return  jb.processFile(null, module, bool, file, info);
	}*/
	
	public boolean processFile(ModuleBase module, boolean bool, File file, RepInfo info) throws Exception {
		this.initModule(module);
		return  jb.processFile(null, module, bool, file, info);
   }

	public static JhoveToolSingleton getInstance() {
		if (instance == null) {
			try {
				instance = new JhoveToolSingleton();
			} catch (FormatValidatorException e) {
				logger.error("JHOVESingleton.getInstance", e);
			}
		}
		return instance;
	}
}
