/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator.tools;

import java.io.File;
import java.util.ArrayList;

import fr.cines.pac.format.Config;
import fr.cines.pac.formatValidator.exception.FormatValidatorException;


/**
 * Classe permettant la validation de fichiers audios en utilisant MPlayer
 */
public class MPlayerAudioTool  extends Tool{
	
	private String specAudio;//,  audioindiq;
	
	private ArrayList<String> authorizedContainerErrors = new ArrayList<String>();
	private ArrayList<String> authorizedAudioErrors = new ArrayList<String>();
	
	private String message;//,  sortieError, sortieStd;
	
	private ProcessHandler processTool;	
	
	//private String cmd[] = new String[11];
	
	/**
	 * correspond à la ligne de commande :
	 * mplayer -vc null -vo null -ao pcm:file=%9%/dev/null -msgmodule -msglevel all=2 file_path
	 * @throws FormatValidatorException 
	 * */
	public MPlayerAudioTool(File file){
		this.file=file;
		//List<String> validAudio, List<String> validContainer, File file) {
/*
		String root = Config.getInstance().getMPlayerPath().getAbsolutePath();
		cmd[0]=root+"/bin/mplayer";
		cmd[1]="-vc";
		cmd[2]="null";
		cmd[3]="-vo";
		cmd[4]="null";
		cmd[5]="-ao";
		cmd[6]="pcm:file=%9%/dev/null";
		cmd[7]="-msgmodule";
		cmd[8]="-msglevel";
		//cmd[9]="all=2";
		cmd[9]=file.getAbsolutePath();
		*/
	}

	public static String[] getCmd(File file){
		String cmd[] = new String[11];
		String root = Config.getInstance().getMPlayerPath().getAbsolutePath();
		cmd[0]=root+"/bin/mplayer";
		cmd[1]="-vc";
		cmd[2]="null";
		cmd[3]="-vo";
		cmd[4]="null";
		cmd[5]="-ao";
		cmd[6]="pcm:file=%9%/dev/null";
		cmd[7]="-msgmodule";
		cmd[8]="-msglevel";
		cmd[9]="all=2";
		cmd[10]=file.getAbsolutePath();
		return cmd;
	}
	
	
	public void run(){	
		processTool = new ProcessHandler(getCmd(this.getFile()));
		processTool.run();
	}
	
	public ProcessHandler getProcessTool(){
		return processTool;
	}
	
	public boolean checkAudio() {
		return checkAudio(this.getProcessTool().getInput()) && checkContainer(this.getProcessTool().getInput()) && checkSpecAudio(this.getProcessTool().getInput());
	}

	private boolean checkSpecAudio(String out) {
		if (specAudio == null) return true;
		else {
			StringBuffer audio = new StringBuffer();
			MPlayerIdentify.readInfo(out, specAudio, audio);
			if (audio.toString().equals("")) { return true; }
			else {
				message+=audio.toString()+'\n'; 
				return false; }
			}
	}
	
	private boolean checkAudio(String out) {
		StringBuffer audio = new StringBuffer();
		int ind = MPlayerIdentify.readInfo(out, "DECAUDIO:", audio);
		if (audio.toString().equals("")) { return true; }
		else {
			if (!authorizedAudioErrors.contains(audio.toString())) { message+=audio.toString()+'\n'; return false; }
			else return checkAudio(out.substring(ind+audio.length()));
		}
	}
	
	private boolean checkContainer(String out) {
		StringBuffer demux = new StringBuffer();
		int ind = MPlayerIdentify.readInfo(out, "DEMUX:", demux);
		if (demux.toString().equals("")) { return true; }
		else {
			if (!authorizedContainerErrors.contains(demux.toString())) { message+=demux.toString()+'\n'; return false; }
			else return checkContainer(out.substring(ind+demux.length()));
		}
	}
 
	
	public void addAuthorizedContainerErrors(String error) {
		authorizedContainerErrors.add(error);
	}
	
	public void addAuthorizedAudioErrors(String error) {
		authorizedAudioErrors.add(error);
	}
	
	public void setSpecAudio(String a) {
		this.specAudio=a;
	}

	public String getMessage() {
		return message;
	}
}
