/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */


package fr.cines.pac.formatValidator.tools;

import java.io.File;

import fr.cines.pac.format.Config;
import fr.cines.pac.formatValidator.exception.FormatValidatorException;

/**
 * Classe permettant d'obtenir un certain nombre d'informations (format audio, format video,
 * container) sur un fichier multimedia en utilisant MPlayer
 *
 */
public class MPlayerIdentify {


	public static final String i_container = "ID_DEMUXER=";
	public static final String i_videoCodec = "ID_VIDEO_FORMAT=";
	public static final String i_audioCodec = "ID_AUDIO_FORMAT=";

	ProcessHandler processTool;

	public MPlayerIdentify() {
	}
	
	public void init(File file) throws FormatValidatorException {
		processTool = new ProcessHandler(getCmd(file));
		processTool.run();
	}

	public static String[] getCmd(File file){
		String cmd[] = new String[11];
		String root = Config.getInstance().getMPlayerPath().getAbsolutePath();
		
		cmd[0]=root+"/bin/mplayer";
		cmd[1]="-vo";
		cmd[2]="null";
		cmd[3]="-ao";
		cmd[4]="null";
		cmd[5]="-frames";
		cmd[6]="0";
		cmd[7]="-identify";
		cmd[8]=file.getAbsolutePath();
		return cmd;
	}
	
	public static int readInfo(String out, String id, StringBuffer info) {
		int i = out.indexOf(id);
		int j=i;
		if (i>=0) {
			while (out.charAt(i) != '\n') {
				info.append(out.charAt(i));
				i++;
			}
		}
		return j;
	}

	public String getAudio() {
		StringBuffer audio= new StringBuffer();
		readInfo(processTool.getInput(), i_audioCodec, audio);
		return audio.toString();
	}

	public String getVideo() {
		StringBuffer video= new StringBuffer();
		MPlayerIdentify.readInfo(processTool.getInput(), i_videoCodec, video);
		return video.toString();
	}

	public String getContainer() {
		StringBuffer container= new StringBuffer();
		readInfo(processTool.getInput(), i_container, container);
		return container.toString();
	}
}
