/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator.tools;

import java.io.File;

import fr.cines.pac.format.Config;

/**
 * implémentation permettant de récupérer des informations sur un fichier multimédia en utilisant MediaInfo
 */
public class MediaInfoTool extends Tool{
	
	public final static String NOT_FOUND="NA";
	
	public final static String GENERAL_COUNT_OF_AUDIO_STREAM ="Count of audio streams";
	public final static String GENERAL_VIDEO_FORMAT_LIST     ="Video_Format_List";
	public final static String FORMAT	=	"Format";
	
	ProcessHandler processTool;
	
	protected boolean  alreadyRun=false;
	private MediaInfoToolReader reader;
	
	public MediaInfoTool(File file){
		this.processTool = new ProcessHandler(getCmd(file));
		this.processTool.run();

		//	this.SetXmlResponse(processTool.getStandardInput());
		//this.setReader(processTool.getStandardInput());
		this.setReader(processTool.getInput());
	}
	
	public static String[] getCmd(File file){
		String root = Config.getInstance().getMediaInfoPath().getAbsolutePath();
		String cmd[] = new String[3];
		cmd[0]= root+"/bin/mediainfo";
	//	cmd[1]= "--Output=XML";
		cmd[1]= "-f";
		cmd[2]=file.getAbsolutePath();
		return cmd;
	}
	
	private void setReader(String response){
		this.reader = new MediaInfoToolTextReader(response);
	}

	public MediaInfoToolReader getReader(){
		return this.reader;
	}
	
	public String getGeneralFormat(){
		return this.getGeneral(FORMAT);
	}
	
	public String getGeneral(String attribut){
		String tmp = this.getReader().getGeneral().get(attribut);
		if(tmp==null) return NOT_FOUND;
		return tmp;
	}
	
	public String getVideoFormat(){
		return this.getVideo(FORMAT);
	}
	
	public String getVideo(String attribut){
		String tmp =  this.getReader().getVideo().get(attribut);
		if(tmp==null) return NOT_FOUND;
		return tmp;
	}
	
	public String getAudioFormat(){
		return this.getAudio(FORMAT);
	}
	
	public String getAudio(String attribut){
		String tmp =  this.getReader().getAudio().get(attribut);
		if(tmp==null) return NOT_FOUND;
		return tmp;
	}
		
	public String getImageFormat(){
		String tmp =  this.getReader().getImage().get("Format");
		if(tmp==null) return NOT_FOUND;
		return tmp;
	}
}