/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator.tools;

import java.util.Hashtable;
import java.util.StringTokenizer;

public class MediaInfoToolReader {

	protected String  response;
	
	/**identifiant de la section generale du message de retour de media info*/
	public final static String GENERAL_SECTION_NAME="General";
	
	/**identifiant de la section VIDEO du message de retour de media info*/
	public final static String VIDEO_SECTION_NAME="Video";
	
	/**identifiant de la section AUDIO du message de retour de media info*/
	public final static String AUDIO_SECTION_NAME="Audio";
	
	/**identifiant de la section IMAGE du message de retour de media info*/
	public final static String IMAGE_SECTION_NAME="Image";
	
	/** contient les paires identifiant/valeur des attributs de chaque sections */
	private java.util.Hashtable<String, String> htGeneral = new Hashtable<String, String>();
	private java.util.Hashtable<String, String> htVideo = new Hashtable<String, String>();
	private java.util.Hashtable<String, String> htAudio = new Hashtable<String, String>();
	private java.util.Hashtable<String, String> htImage = new Hashtable<String, String>();

	public MediaInfoToolReader(String response){
		this.response = response;
		boolean general=false,video=false,audio=false,image=false;
		
		StringTokenizer st = new StringTokenizer(this.response,"\n\r");
	    while (st.hasMoreTokens()) {
	    	Line line = new Line(st.nextToken());
	    	
	    	 if(line.beginSection(GENERAL_SECTION_NAME)){ general=true;video=false;audio=false; image=false;}
	    	 if(line.beginSection(VIDEO_SECTION_NAME)){  general=false;video=true;audio=false; image=false;}
	    	 if(line.beginSection(AUDIO_SECTION_NAME)){  general=false;video=false;audio=true; image=false;}
	    	 if(line.beginSection(IMAGE_SECTION_NAME)) { general=false;video=false;audio=false; image=true;}
	    	 
	    	 
	    	 if(general) htGeneral.put(line.getAttributeName(), line.getAttributeValue());
	    	 if(video) htVideo.put(line.getAttributeName(), line.getAttributeValue());
	    	 if(audio) htAudio.put(line.getAttributeName(), line.getAttributeValue());
	    	 if(image) htImage.put(line.getAttributeName(), line.getAttributeValue());
	    }
	}
	
	public  java.util.Hashtable<String, String>  getGeneral(){
		return htGeneral;
	}
	
	public  java.util.Hashtable<String, String> getVideo(){
		return htVideo;
	}
	
	public  java.util.Hashtable<String, String> getAudio(){
		return htAudio;
	}
	
	public  java.util.Hashtable<String, String> getImage(){
		return htImage;
	}
		
}

/** sous implementation d'une ligne de reponse media info*/
class Line{
	String content;
	public Line(String content){
		this.content = content;
	}
	
	boolean beginSection(String idSection){
		return this.content.trim().equalsIgnoreCase(idSection);
	}
	
	String getAttributeName(){
		try{
		return this.content.split(":")[0].trim();
		}catch(Exception e){
			return this.content.trim();
		}
	}
	
	String getAttributeValue(){
		try{
			return this.content.split(":")[1].trim();
			}catch(Exception e){
				return "";
			}
		}
}
