package fr.cines.pac.formatValidator.tools;

import java.io.IOException;
import java.io.Reader;
import java.io.StringReader;
import java.util.List;

import org.apache.log4j.Logger;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;

public class MediaInfoXmlReader extends MediaInfoToolReader {

	MediaInfoTrackXmlElement 	generalEl	= new MediaInfoTrackXmlElement();
	MediaInfoTrackXmlElement 	videoEl 	= new MediaInfoTrackXmlElement();
	MediaInfoTrackXmlElement 	audioEl		= new MediaInfoTrackXmlElement();
	MediaInfoTrackXmlElement 	imageEl		= new MediaInfoTrackXmlElement();


	@SuppressWarnings("unchecked")
	private MediaInfoXmlReader(String xmlResponse) throws JDOMException, IOException{
		super(xmlResponse);
		SAXBuilder sxb = new SAXBuilder();
		Document document;
		// On crée un nouveau document JDOM avec en argument le fichier XML
		// Le parsing est terminé ;)
		if(xmlResponse ==null) return;
		if(xmlResponse.isEmpty()) return;
		Reader reader = new StringReader(xmlResponse);
		document = sxb.build(reader);
		Element eFile = document.getRootElement().getChild("File");
		List<Element> trackList = eFile.getChildren("track");
		for(Element e :trackList ){
			String type = e.getAttribute("type").getValue();
			if(type.equalsIgnoreCase(GENERAL_SECTION_NAME)) generalEl = new MediaInfoTrackXmlElement(e);
			if(type.equalsIgnoreCase(VIDEO_SECTION_NAME)) videoEl= new MediaInfoTrackXmlElement(e);
			if(type.equalsIgnoreCase(AUDIO_SECTION_NAME)) audioEl = new MediaInfoTrackXmlElement(e);
			if(type.equalsIgnoreCase(IMAGE_SECTION_NAME)) imageEl= new MediaInfoTrackXmlElement(e);
		}
	}



}

/*
 * classe interne
 * */
class MediaInfoTrackXmlElement {

	Logger logger = Logger.getLogger(getClass().getSimpleName());
	Element e;

	String format, formatProfil, formatInfo;;

	public MediaInfoTrackXmlElement(Element e) {
		this.e = e;
		this.format = this.getMetaData("Format");
		this.formatProfil = this.getMetaData("Format_profile");
		this.formatInfo = this.getMetaData("Format_Info");
		if(this.format!=null){
			logger.debug("read result : Format="+this.format);
		}else{
			logger.warn("unable to read Format : show result : "+e.getContent());
		}
	}

	public MediaInfoTrackXmlElement() {
		// TODO Auto-generated constructor stub
	}

	/**
	 * @return the format
	 */
	public String getFormat() {
		return format;
	}

	/**
	 * @return the formatProfil
	 */
	public String getFormatProfil() {
		return formatProfil;
	}

	/**
	 * @return the formatInfo
	 */
	public String getFormatInfo() {
		return formatInfo;
	}

	public String getMetaData(String name){
		try{
			return e.getChild(name).getValue().trim();
		}catch(Exception e){
			logger.debug("unable to read metada named :"+name);
			return "NA";
		}
	}

}
