/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator.tools;

import java.io.PrintStream;
import java.util.Vector;


import odfvalidator.ODFValidator;
import odfvalidator.ODFValidatorException;

/**
 * Classe permettant d'utiliser l'outil de validation ODFValidator
 *
 */
public class OdfToolSingleton extends Tool{
	
    public static final int INFO = 2;
    public static final int WARNING = 1;
    public static final int ERROR = 0;
    
    public static final int CHECK_CONFORMANCE = 0;
    public static final int VALIDATE = 1;
    public static final int VALIDATE_STRICT = 2;
	
    
	private ODFValidator validator;
	private static OdfToolSingleton instance;
	
	private OdfToolSingleton() throws ODFValidatorException {
			//pprat
			System.setProperty("javax.xml.validation.SchemaFactory:http://relaxng.org/ns/structure/1.0","org.iso_relax.verifier.jaxp.validation.RELAXNGSchemaFactoryImpl");
			System.setProperty("org.iso_relax.verifier.VerifierFactoryLoader","com.sun.msv.verifier.jarv.FactoryLoaderImpl");
			validator = new ODFValidator(null, INFO, null, false);
	}
	
	public static OdfToolSingleton getInstance() throws ODFValidatorException {
		if (instance == null) {
			instance = new OdfToolSingleton();
		}
		return instance;
	}
	
	public boolean validate(String file, PrintStream p) {
		boolean b = true;
		Vector<String> v = new Vector<String>();
		try {
			v.add(file);
			b = validator.validate(p, v, null, VALIDATE, false, null);
		} catch (Exception e) {
			logger.error("ODFSingleton.validate", e);
		}
		return (!b);
	}
	
	public boolean validateStrict(String file, PrintStream p) {
		boolean b = true;
		Vector<String> v = new Vector<String>();
		try {
			v.add(file);
			b = validator.validate(p, v, null, VALIDATE_STRICT, false, null);
			p.flush();
		} catch (Exception e) {
			logger.error("ODFSingleton.validateStrict", e);
		}
		return (!b);
	}
}
