/**
 * @author prat@cines.fr
 * last maj : 2010/08/02
 * */

package fr.cines.pac.formatValidator.tools;

import org.apache.log4j.Logger;

/**
 * implémenation permettant d'utiliser les applications sur le système du serveur hote 
 * et d'en avoir le retour sou forme de chaine de caractère java.
 * */

public class ProcessHandler {

	private static Logger logger = Logger.getLogger(ProcessHandler.class);

	String[]  command;
	private String input="";
	Process process = null;
	ProcessBuilder processBuilder = null;
	
	public ProcessHandler(String[]  command ){
		this.command =command;
		this.processBuilder = new ProcessBuilder(this.command);
		this.processBuilder.redirectErrorStream(true);
	}
	
	public void run(){
		try {
			logger.debug("exec process="+this.getCommandLine());
			this.process = processBuilder.start();
			
		} catch (Exception e) {
			logger.error(e);
			e.printStackTrace();
		}
		ThreadStreamReader reader = new ThreadStreamReader(this.process.getInputStream());
		reader.run();
		this.input = reader.getSortie();
	}
	
	/** 0 is ok */
	public int getExitValue_(){
		try {
			this.process.waitFor();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return this.process.exitValue();
	}
           
    public String getInput(){
    	return this.input;
    }
    
    public String getCommandLine(){
    	return getStringValue(this.command);
    }
    
    public static String getStringValue(String[] strTab){
    	String out ="";
    	for(String s : strTab){
    		out = out+s+" ";
    	}
    	return out.trim();
    }
    
    public Process getProcess(){
    	return this.process;
    }
    
    public ProcessBuilder getProcessBuilder(){
    	return this.processBuilder;
    }
}