package fr.cines.pac.formatValidator.tools;

import java.io.File;
import java.util.ArrayList;

import edu.harvard.hul.ois.jhove.ModuleBase;

public class ToolsMgr {
	
	private File file;
	
	private JhoveTool 			jhoveTool;
	private MediaInfoTool		mediaInfoTool;
	private MPlayerAudioTool	mplayerAudioTool;
	private SaxXmlTool			cinesXmlTool;
	private MEncoderTool 		mEncoder;
	private OdfTool				odfTool;
	private	DroidTool			droidTool;
	private IMagickTool			iMagickTool;
	
	@SuppressWarnings("unchecked")
	ArrayList<Class> toolsList;
	
	public ToolsMgr(File file){
		this.file = file;
	}
	
	public MEncoderTool getMEncoder(){
		if(this.mEncoder == null){
			this.mEncoder = new MEncoderTool(this.getFile());
			this.getToolsList().add(this.mEncoder.getClass());
		}
		return this.mEncoder;
	}
	
	public JhoveTool getJhoveTool(){
		return this.jhoveTool;
	}
	
	public void setJhoveTool(ModuleBase module){
		this.jhoveTool = new JhoveTool(module, this.getFile());
		this.getToolsList().add(this.jhoveTool.getClass());
	}
	
	public MediaInfoTool getMediaInfoTool(){
		if(this.mediaInfoTool == null){
			this.mediaInfoTool = new MediaInfoTool(this.getFile());
			this.getToolsList().add(this.mediaInfoTool.getClass());
		}
		return this.mediaInfoTool;
	}	
	
	public MPlayerAudioTool getMPlayerAudioTool(){
		if(this.mplayerAudioTool == null){
			this.mplayerAudioTool = new MPlayerAudioTool(this.getFile()); 
			this.getToolsList().add(this.mplayerAudioTool.getClass());
		}
		return this.mplayerAudioTool;
	}
	

	public SaxXmlTool getCinesXmlTool(){
		if(this.cinesXmlTool==null) {
			this.cinesXmlTool = new SaxXmlTool(this.getFile());
			this.getToolsList().add(this.cinesXmlTool.getClass());
		}
		return this.cinesXmlTool;
	}
	
	public OdfTool getOdfTool(){
		if(this.odfTool==null){
			this.odfTool = new OdfTool(this.getFile());
			this.getToolsList().add(this.odfTool.getClass());
		}
		return this.odfTool;
	}
	
	public DroidTool getDroidTool() {
		return this.droidTool;
	}
	
	public void setDroidTool(int[] validDroidIds){
		this.droidTool = new DroidTool(validDroidIds);
		this.droidTool.init(this.getFile());
		this.getToolsList().add(this.droidTool.getClass());
	}
	
	public IMagickTool getIMagickTool(){
		if(this.iMagickTool==null)
			this.iMagickTool = new IMagickTool(this.getFile());
		return this.iMagickTool;
	}
	
	private File getFile(){
		return this.file;
	}
	
	@SuppressWarnings("unchecked")
	public ArrayList<Class> getToolsList(){
		if(this.toolsList==null){
			this.toolsList= new ArrayList<Class>();
		}
		return this.toolsList;
	}
}
