package fr.cines.pac.formatValidator.util;

import java.io.File;

import org.apache.log4j.Logger;

import fr.cines.pac.format.FormatConf;
import fr.cines.pac.formatValidator.Validator;
import fr.cines.pac.formatValidator.exception.FormatValidatorException;

public class FSValidatorHandler   implements WalkerHandler{

	/** sous chaine de caractère detectable dans le chemin absolut du fichier
	 * permettant de specifier qu'un fichier ne doit pas etre valide
	 * */
	
	public static String SUB_STR_KO="-ko";

	private  Logger logger = Logger.getLogger(this.getClass().getName());

	@Override
	public void processDirectory(File file) {
	}

	@Override
	public void processFile(File file) throws FormatValidatorException {
		logger.debug("process file:"+file.getAbsolutePath());
		String formatShortName=null;
		try{
			formatShortName = FormatConf.getFormatConfFromFileName(file.getName()).getshortName();
		}catch(Exception e){
			//doNothing
		}
		Validator validator = Validator.getValidatorFromPacFormatId(formatShortName);
		validator.init(file);
		
		String logLine = validator.getClass().getName()+
		": format="+validator.getFormatToolsInfo().getShortName()+
		", version="+validator.getFormatToolsInfo().getVersion()+
		", arch="+Util.unzero(validator.isArchivable())+
		", val="+Util.unzero(validator.isValid())+
		", wf="+Util.unzero(validator.isWellFormed())+
		", file="+file.getAbsolutePath()+
		", mess="+validator.getMessage();
		
		logger.info(logLine);
		// test : le fichier doit etre non archivable
		if(file.getAbsolutePath().contains(SUB_STR_KO) || formatShortName==null){
			if(validator.isArchivable()) 
				logger.error("le fichier : "+file.getAbsolutePath()+" ne doit pas etre archivable");
		}else{
			if(!validator.isArchivable()) logger.error("le fichier : "+file.getAbsolutePath()+" doit etre archivable");
		}
	}
}