package fr.cines.pac.formatValidator.util;

import java.io.*;

import fr.cines.pac.formatValidator.exception.FormatValidatorException;

public class FSWalker{
	
	private WalkerHandler handler;
	private File root;
	/**
	 * filtre les repertoires
	 * */
	private static FileFilter directory_filter = new FileFilter() {
		public boolean accept(java.io.File file) {
			return file.isDirectory();
		}
	};

	/**
	 * filtre les fichiers
	 * */
	private static FileFilter file_filter = new FileFilter() {
		public boolean accept(java.io.File file) {
			return !file.isDirectory();
		}
	};
	
	public FSWalker(java.io.File root, WalkerHandler handler){
		this.handler = handler;
		this.root = root;
	}

	public void start() throws FormatValidatorException {
		processDirectory(this.root);
	}
	
	private WalkerHandler getHandler(){
		return this.handler;
	}
	
	private  void processDirectory(java.io.File currentFile) throws FormatValidatorException {
		
		if(!currentFile.isDirectory()){
			this.getHandler().processFile(currentFile);
			return;
		} 
		/* list files in directory*/
		if(currentFile.isDirectory())
		for(File file : currentFile.listFiles(file_filter)){
			this.getHandler().processFile(file);
		}
		
		/* list directories in directory*/
		if(currentFile.isDirectory())
		for(File directory : currentFile.listFiles(directory_filter)){
			this.getHandler().processDirectory(directory);
			processDirectory(directory);
		}
	}
	
	public File getRootDirectory(){
		return this.root;
	}
	
}