package fr.cines.pac.formatValidator.util;

import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Schema;
import javax.xml.XMLConstants;
import javax.xml.transform.sax.SAXSource;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import fr.cines.pac.formatValidator.exception.FormatValidatorException;

import javax.xml.validation.Validator;
import java.io.*;

public class XsdSchemaSaxValidator {

   public static void validateXml(String  schemaName, String xmlName) throws FormatValidatorException {
	  try {
	  Schema schema = loadSchema(schemaName);
      // creating a Validator instance
      Validator validator = schema.newValidator();
      // preparing the XML file as a SAX source
      SAXSource	source = new SAXSource( new InputSource(new java.io.FileInputStream(xmlName)));

      // validating the SAX source against the schema
    	validator.validate(source);
	} catch (SAXParseException sae) {
		String message = "line="+sae.getLineNumber()+"column="+sae.getColumnNumber();
		throw new FormatValidatorException(message,sae);

	} catch (Exception e) {
		// TODO Auto-generated catch block
		throw new FormatValidatorException(e);
	}
      
  }
  
  public static Schema loadSchema(String name) throws SAXException {
     Schema schema = null;
      String language = XMLConstants.W3C_XML_SCHEMA_NS_URI;
      SchemaFactory factory = SchemaFactory.newInstance(language);
      schema = factory.newSchema(new File(name));
     return schema;
  }
}
